﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace TestEditorTemplate
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = getDataSource();

            ultraGrid1.DisplayLayout.ValueLists.Clear();

            ultraGrid1.DisplayLayout.ValueLists.Add(getColumn1ValueList());
            ultraGrid1.DisplayLayout.Bands[0].Columns["Column1"].ValueList = ultraGrid1.DisplayLayout.ValueLists["Column1"];
        }

        private ValueList getColumn1ValueList()
        {
            var list = new ValueList { Key = "Column1" };
            var item = new ValueListItem { DataValue = 1, DisplayText = "English"};
            list.ValueListItems.Add(item);
            item = new ValueListItem { DataValue = 2, DisplayText = "Italian" };
            list.ValueListItems.Add(item);
            item = new ValueListItem { DataValue = 3, DisplayText = "French" };
            list.ValueListItems.Add(item);

            return list;
        }

        private void setColumn2ValueList(UltraGridRow row)
        {
            ValueList list = null;
            var value = (int)row.Cells["Column1"].Value;
            var key = "Column2_" + value;
            if(value > 0)
            {
                if (!ultraGrid1.DisplayLayout.ValueLists.Exists(key))
                {
                    switch (value)
                    {
                        case 1:
                            list = new ValueList { Key = key };
                            var item = new ValueListItem { DataValue = 1, DisplayText = "One" };
                            list.ValueListItems.Add(item);
                            item = new ValueListItem { DataValue = 2, DisplayText = "Two" };
                            list.ValueListItems.Add(item);
                            item = new ValueListItem { DataValue = 3, DisplayText = "Three" };
                            list.ValueListItems.Add(item);
                            break;

                        case 2:
                            list = new ValueList { Key = "Column2_" + value };
                            item = new ValueListItem { DataValue = 1, DisplayText = "Uno" };
                            list.ValueListItems.Add(item);
                            item = new ValueListItem { DataValue = 2, DisplayText = "Due" };
                            list.ValueListItems.Add(item);
                            item = new ValueListItem { DataValue = 3, DisplayText = "Tre" };
                            list.ValueListItems.Add(item);
                            break;

                        case 3:
                            list = new ValueList { Key = "Column2_" + value };
                            item = new ValueListItem { DataValue = 1, DisplayText = "Un" };
                            list.ValueListItems.Add(item);
                            item = new ValueListItem { DataValue = 2, DisplayText = "Deux" };
                            list.ValueListItems.Add(item);
                            item = new ValueListItem { DataValue = 3, DisplayText = "Trois" };
                            list.ValueListItems.Add(item);
                            break;

                    }
                    if (list != null)
                        ultraGrid1.DisplayLayout.ValueLists.Add(list);
                }

                row.Cells["Column2"].ValueList = ultraGrid1.DisplayLayout.ValueLists[key];
                
            }
        }

        private BindingList<Source> getDataSource()
        {
            return new BindingList<Source>()
            {
                new Source {Column1 = 1, Column2 = 2},
                new Source {Column1 = 2, Column2 = 1},
                new Source {Column1 = 3, Column2 = 3}
            };
        }

        private void ultraGrid1_AfterCellUpdate(object sender, CellEventArgs e)
        {
            setColumn2ValueList(e.Cell.Row);
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            setColumn2ValueList(e.Row);
        }

        private void btnTemplateOk_Click(object sender, EventArgs e)
        {
            // This code was automatically generated by the RowEditTemplate Wizard
            // 
            // Close the template and save any pending changes.
            this.ultraGridRowEditTemplate1.Close(true);

        }

        private void btnTemplateCancel_Click(object sender, EventArgs e)
        {
            // This code was automatically generated by the RowEditTemplate Wizard
            // 
            // Close the template and discard any pending changes.
            this.ultraGridRowEditTemplate1.Close(false);

        }

    }

    public class ColumnValueDto
    {
        public int Id { get; set; }
        public string Description { get; set; }
    }

    public class Source
    {
        public int Column1 { get; set; }
        public int Column2 { get; set; }
    }
}
